Framework MaxGui.Drivers
Import BRL.D3D9Max2D
Import BRL.PNGLoader
Import BRL.EventQueue
Import BRL.Random

SeedRnd(MilliSecs());

AppTitle = "Map Generator";
Include "gui.bmx"
Include "map.bmx"
Include "generator.bmx"
Global Image:TImage;
Global ViewX, ViewY, MoveX, MoveY, Moving;

Local terminate
While Not terminate
	
	If Moving Then
		If MouseDown(1) Then
			ViewX = MoveX - MouseX();
			ViewY = MoveY - MouseY();
		Else
			Moving = False;
		EndIf
	Else
		If MouseHit(1) Then
			Moving = True;
			MoveX = MouseX() + ViewX;
			MoveY = MouseY() + ViewY;
		EndIf
	EndIf
	
	Cls;
	If Image Then DrawImage(Image, -ViewX, -ViewY);
	Delay(4);
	Flip;
	
	Local f$
	
	PollEvent();
	Select EventID()
		Case EVENT_WINDOWCLOSE
			If TGadget(EventSource()) = wiMain Then
				End
			Else
				HideGadget(TGadget(EventSource()));
			EndIf
		
		Case EVENT_GADGETACTION
			Select TGadget(EventSource())
				Case buOpt
					SetGadgetShape(wiOptions, GadgetX(wiMain) - 10 - (GadgetWidth(wiMain) / 2), GadgetY(wiMain), GadgetWidth(wiOptions), GadgetHeight(wiOptions));
					ShowGadget(wiOptions);
					
				Case buCre
					Notify("Written by mafia_man.~nU.S.G.N ID: 9102");
				
				Case buExit
					End;
				
				Case buGen
					Generate();
				
				Case buSav
					f = RequestFile("Save map", "Map File:map", True);
					If Len(f) > 0 Then
						saveMap(f);
					EndIf
				
				Case buExp
					f = RequestFile("Export view", "Image File:png", True);
					If Len(f) > 0 Then
						SavePixmapPNG(LockImage(Image), f);
					EndIf
			EndSelect
			
	EndSelect
Wend